# Class VulkanStencilOpState.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanStencilOpState.Builder

Enclosing class:
  `VulkanStencilOpState`

public static final class VulkanStencilOpState.Builder extends Object
Builds instances of type `VulkanStencilOpState`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanStencilOpState`
  `build()`
  Builds a new `VulkanStencilOpState`.
  `final VulkanStencilOpState.Builder`
  `from(VulkanStencilOpStateType instance)`
  Fill a builder with attribute values from the provided `VulkanStencilOpStateType` instance.
  `final VulkanStencilOpState.Builder`
  `setCompareMask(int compareMask)`
  Initializes the value for the `compareMask` attribute.
  `final VulkanStencilOpState.Builder`
  `setCompareOp(VulkanCompareOp compareOp)`
  Initializes the value for the `compareOp` attribute.
  `final VulkanStencilOpState.Builder`
  `setDepthFailOp(VulkanStencilOp depthFailOp)`
  Initializes the value for the `depthFailOp` attribute.
  `final VulkanStencilOpState.Builder`
  `setFailOp(VulkanStencilOp failOp)`
  Initializes the value for the `failOp` attribute.
  `final VulkanStencilOpState.Builder`
  `setPassOp(VulkanStencilOp passOp)`
  Initializes the value for the `passOp` attribute.
  `final VulkanStencilOpState.Builder`
  `setReference(int reference)`
  Initializes the value for the `reference` attribute.
  `final VulkanStencilOpState.Builder`
  `setWriteMask(int writeMask)`
  Initializes the value for the `writeMask` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanStencilOpState.Builder from(VulkanStencilOpStateType instance)
    Fill a builder with attribute values from the provided `VulkanStencilOpStateType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setFailOp

    public final VulkanStencilOpState.Builder setFailOp(VulkanStencilOp failOp)
    Initializes the value for the `failOp` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `failOp`.

    Parameters:
      `failOp` - The value for failOp
    Returns:
      `this` builder for use in a chained invocation

  - ### setPassOp

    public final VulkanStencilOpState.Builder setPassOp(VulkanStencilOp passOp)
    Initializes the value for the `passOp` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `passOp`.

    Parameters:
      `passOp` - The value for passOp
    Returns:
      `this` builder for use in a chained invocation

  - ### setDepthFailOp

    public final VulkanStencilOpState.Builder setDepthFailOp(VulkanStencilOp depthFailOp)
    Initializes the value for the `depthFailOp` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `depthFailOp`.

    Parameters:
      `depthFailOp` - The value for depthFailOp
    Returns:
      `this` builder for use in a chained invocation

  - ### setCompareOp

    public final VulkanStencilOpState.Builder setCompareOp(VulkanCompareOp compareOp)
    Initializes the value for the `compareOp` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `compareOp`.

    Parameters:
      `compareOp` - The value for compareOp
    Returns:
      `this` builder for use in a chained invocation

  - ### setCompareMask

    public final VulkanStencilOpState.Builder setCompareMask(int compareMask)
    Initializes the value for the `compareMask` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `compareMask`.

    Parameters:
      `compareMask` - The value for compareMask
    Returns:
      `this` builder for use in a chained invocation

  - ### setWriteMask

    public final VulkanStencilOpState.Builder setWriteMask(int writeMask)
    Initializes the value for the `writeMask` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `writeMask`.

    Parameters:
      `writeMask` - The value for writeMask
    Returns:
      `this` builder for use in a chained invocation

  - ### setReference

    public final VulkanStencilOpState.Builder setReference(int reference)
    Initializes the value for the `reference` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `reference`.

    Parameters:
      `reference` - The value for reference
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanStencilOpState build()
    Builds a new `VulkanStencilOpState`.
    Returns:
      An immutable instance of VulkanStencilOpState
    Throws:
      `IllegalStateException` - if any required attributes are missing